/* Problem URL: https://codeforces.com/problemset/problem/1794/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;

constexpr int MAXN = 1e6 + 10;
bool prime[MAXN];
ll fact[MAXN];
ll inv[MAXN];
ll finv[MAXN];

ll mod = 998244353;

void pre()
{
    fill(prime, prime + MAXN, true);
    prime[1] = false;

    nrep(i, 2, MAXN) {
        if (!prime[i]) {
            continue;
        }

        for (int j = i * 2; j < MAXN; j += i) {
            prime[j] = false;
        }
    }

    fact[0] = 1;
    nrep(i, 1, MAXN) {
        fact[i] = fact[i - 1] * i % mod;
    }

    inv[1] = 1;
    nrep(i, 2, MAXN) {
        inv[i] = (mod - mod / i) * inv[mod % i] % mod;
    }

    finv[0] = 1;
    nrep(i, 1, MAXN) {
        finv[i] = finv[i - 1] * inv[i] % mod;
    }
}

#define TEST 0

void solve()
{
    int n;
    cin >> n;
    vi a(2 * n);
    cin >> a;

    vi primes;
    map<int, ll> c;
    rep(i, 2 * n) {
        if (prime[a[i]] && !c.count(a[i])) {
            primes.push_back(a[i]);
        }

        c[a[i]]++;
    }

    if (primes.size() < n) {
        cout << "0\n";
        return;
    }

    ll non = 1;
    repv(i, c) {
        if (!prime[i.first]) {
            non = (non * finv[i.second]) % mod;
        }
    }

    vvl dp(primes.size() + 1, vl(n + 1));
    dp[0][0] = fact[n] * non % mod;

    nrep(i, 1, primes.size() + 1) {
        int cur = primes[i - 1];
        ll co = c[cur];
        dp[i][0] = dp[i - 1][0] * finv[co] % mod;

        nrep(j, 1, n + 1) {
            dp[i][j] = (dp[i - 1][j] * finv[co] % mod + dp[i - 1][j - 1] * finv[co - 1] % mod) % mod;
        }
    }

    cout << dp[primes.size()][n] << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
